commit 9d7e72cdb70802032ebdd835052808f020c066a4
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Mon Jul 4 10:18:00 2022 +0200

    Correct the order.

diff --git a/src/main/java/org/distorted/objectlib/main/ObjectType.java b/src/main/java/org/distorted/objectlib/main/ObjectType.java
index a44f794a..8ffc46d7 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectType.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectType.java
@@ -38,51 +38,60 @@ public enum ObjectType
   CUBE_4 ( TwistyCuboid.class        , 24, R.drawable.cube_4, true, new InitData(new int[] {4,4,4})),
   CUBE_5 ( TwistyCuboid.class        , 28, R.drawable.cube_5, true, new InitData(new int[] {5,5,5})),
   CUBE_6 ( TwistyCuboid.class        , 35, R.drawable.cube_6, true, new InitData(new int[] {6,6,6})),
+
   CUBE_7 ( TwistyCuboid.class        , 42, R.drawable.cube_7, true, new InitData(new int[] {7,7,7})),
-  CU_323 ( TwistyCuboid.class        , 15, R.drawable.cu_323, true, new InitData(new int[] {3,2,3})),
-  CU_232 ( TwistyCuboid.class        , 16, R.drawable.cu_232, true, new InitData(new int[] {2,3,2})),
-  CU_343 ( TwistyCuboid.class        , 23, R.drawable.cu_343, true, new InitData(new int[] {3,4,3})),
-  VOID_3 ( TwistyVoid.class          , 17, R.drawable.void_3, true, new InitData(new int[] {3,3,3})),
   BAN1_3 ( TwistyBandagedCuboid.class, 16, R.drawable.ban1_3, true, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_1)),
   BAN2_3 ( TwistyBandagedCuboid.class, 20, R.drawable.ban2_3, true, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_2)),
   BAN3_3 ( TwistyBandagedCuboid.class, 16, R.drawable.ban3_3, true, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_3)),
   BAN4_3 ( TwistyBandagedCuboid.class, 22, R.drawable.ban4_3, true, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_4)),
-  FISH_3 ( TwistyFisher.class        , 24, R.drawable.fish_3, true, new InitData(new int[] {3,3,3})),
-  WIND_3 ( TwistyWindmill.class      , 24, R.drawable.wind_3, true, new InitData(new int[] {3,3,3})),
-  AXIS_3 ( TwistyAxis.class          , 24, R.drawable.axis_3, true, new InitData(new int[] {3,3,3})),
+
+  CU_323 ( TwistyCuboid.class        , 15, R.drawable.cu_323, true, new InitData(new int[] {3,2,3})),
+  CU_232 ( TwistyCuboid.class        , 16, R.drawable.cu_232, true, new InitData(new int[] {2,3,2})),
+  CU_343 ( TwistyCuboid.class        , 23, R.drawable.cu_343, true, new InitData(new int[] {3,4,3})),
   SQU1_3 ( TwistySquare1.class       , 24, R.drawable.squ1_3, true, new InitData(new int[] {3,2,3})),
   SQU2_3 ( TwistySquare2.class       , 24, R.drawable.squ2_3, true, new InitData(new int[] {3,2,3})),
+
   MORP_2 ( TwistyMorphix.class       , 12, R.drawable.morp_2, true, new InitData(new int[] {2,2,2})),
   JING_2 ( TwistyJing.class          , 11, R.drawable.jing_2, true, new InitData(new int[] {2,2,2,2})),
   PYRA_3 ( TwistyPyraminx.class      , 10, R.drawable.pyra_3, true, new InitData(new int[] {3,3,3,3})),
   PYRA_4 ( TwistyPyraminx.class      , 17, R.drawable.pyra_4, true, new InitData(new int[] {4,4,4,4})),
   PYRA_5 ( TwistyPyraminx.class      , 23, R.drawable.pyra_5, true, new InitData(new int[] {5,5,5,5})),
+
   TRAJ_3 ( TwistyTrajber.class       , 17, R.drawable.traj_3, true, new InitData(new int[] {3,3,3})),
   TRAJ_4 ( TwistyTrajber.class       , 24, R.drawable.traj_4, true, new InitData(new int[] {4,4,4})),
   DIAM_2 ( TwistyDiamond.class       , 12, R.drawable.diam_2, true, new InitData(new int[] {2,2,2,2})),
   DIAM_3 ( TwistyDiamond.class       , 24, R.drawable.diam_3, true, new InitData(new int[] {3,3,3,3})),
   DIAM_4 ( TwistyDiamond.class       , 32, R.drawable.diam_4, true, new InitData(new int[] {4,4,4,4})),
+
   ULTI_2 ( TwistyUltimate.class      , 18, R.drawable.ulti_2, true, new InitData(new int[] {2,2,2,2})),
   KILO_3 ( TwistyKilominx.class      , 18, R.drawable.kilo_3, true, new InitData(new int[] {3,3,3,3,3,3})),
   MEGA_3 ( TwistyMegaminx.class      , 21, R.drawable.mega_3, true, new InitData(new int[] {3,3,3,3,3,3})),
   KILO_5 ( TwistyKilominx.class      , 33, R.drawable.kilo_5, true, new InitData(new int[] {5,5,5,5,5,5})),
   MEGA_5 ( TwistyMegaminx.class      , 37, R.drawable.mega_5, true, new InitData(new int[] {5,5,5,5,5,5})),
+
   CRYS_3 ( TwistyCrystal.class       , 27, R.drawable.crys_3, true, new InitData(new int[] {3,3,3,3,3,3})),
   STAR_3 ( TwistyStarminx.class      , 27, R.drawable.star_3, true, new InitData(new int[] {3,3,3,3,3,3})),
   PENT_2 ( TwistyPentultimate.class  , 21, R.drawable.pent_2, true, new InitData(new int[] {2,2,2,2,2,2})),
   DINO_3 ( TwistyDino6.class         , 10, R.drawable.dino_3, true, new InitData(new int[] {3,3,3,3})),
   DIN4_3 ( TwistyDino4.class         ,  7, R.drawable.din4_3, true, new InitData(new int[] {3,3,3,3})),
+
   MIRR_2 ( TwistyMirror.class        , 12, R.drawable.mirr_2, true, new InitData(new int[] {2,2,2})),
   MIRR_3 ( TwistyMirror.class        , 17, R.drawable.mirr_3, true, new InitData(new int[] {3,3,3})),
   MIRR_4 ( TwistyMirror.class        , 24, R.drawable.mirr_4, true, new InitData(new int[] {4,4,4})),
   IVY_2  ( TwistyIvy.class           ,  8, R.drawable.ivy_2 , true, new InitData(new int[] {2,2,2,2})),
   REX_3  ( TwistyRex.class           , 19, R.drawable.rex_3 , true, new InitData(new int[] {3,3,3,3})),
+
   REDI_3 ( TwistyRedi.class          , 16, R.drawable.redi_3, true, new InitData(new int[] {3,3,3,3})),
   HELI_3 ( TwistyHelicopter.class    , 20, R.drawable.heli_3, true, new InitData(new int[] {3,3,3,3,3,3})),
   SKEW_2 ( TwistySkewb.class         , 11, R.drawable.skew_2, true, new InitData(new int[] {2,2,2,2})),
   SKEW_3 ( TwistySkewb.class         , 21, R.drawable.skew_3, true, new InitData(new int[] {3,3,3,3})),
   CONT_2 ( TwistyContainer.class     , 12, R.drawable.cont_2, true, new InitData(new int[] {2,2,2,2})),
 
+  FISH_3 ( TwistyFisher.class        , 24, R.drawable.fish_3, true, new InitData(new int[] {3,3,3})),
+  WIND_3 ( TwistyWindmill.class      , 24, R.drawable.wind_3, true, new InitData(new int[] {3,3,3})),
+  AXIS_3 ( TwistyAxis.class          , 24, R.drawable.axis_3, true, new InitData(new int[] {3,3,3})),
+  VOID_3 ( TwistyVoid.class          , 17, R.drawable.void_3, true, new InitData(new int[] {3,3,3})),
+
   MIXU_3 ( TwistyMixup3x3.class      , 24, R.drawable.mixu_3, false, new InitData(new int[] {3,3,3})),   // wasDownloadableButNowIsBuiltIn()
   MIXP_3 ( TwistyMixup3x3Plus.class  , 28, R.drawable.mixp_3, false, new InitData(new int[] {3,3,3})),
   CRA1_2 ( TwistyCrazy2x2.class      , 16, R.drawable.cra1_2, false, new InitData(new int[] {2,2,2})),