commit c8bc83d9b8c0f1efd19d4b443b8f4aaec3943203
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Fri Oct 1 22:33:06 2021 +0200

    Simplify TwistyObject's API.

diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index 86daea91..8e433895 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -354,6 +354,26 @@ public abstract class TwistyObject extends DistortedNode
       }
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private int getMultQuat(int index1, int index2)
+    {
+    if( mQuatMult==null )
+      {
+      mQuatMult = new int[NUM_QUATS][NUM_QUATS];
+
+      for(int i=0; i<NUM_QUATS; i++)
+        for(int j=0; j<NUM_QUATS; j++) mQuatMult[i][j] = -1;
+      }
+
+    if( mQuatMult[index1][index2]==-1 )
+      {
+      mQuatMult[index1][index2] = mulQuat(index1,index2);
+      }
+
+    return mQuatMult[index1][index2];
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // This is used to build internal data structures for the generic 'isSolved()'
 //
@@ -362,7 +382,7 @@ public abstract class TwistyObject extends DistortedNode
 // Color index, i.e. the index into the 'FACE_COLORS' table.
 // else (edge or corner cubit, more than one non-black face): return -2.
 
-  public int retCubitSolvedStatus(int cubit, int numLayers)
+  protected int retCubitSolvedStatus(int cubit, int numLayers)
     {
     int numNonBlack=0, nonBlackIndex=-1, color;
 
@@ -385,14 +405,14 @@ public abstract class TwistyObject extends DistortedNode
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public boolean shouldResetTextureMaps()
+  protected boolean shouldResetTextureMaps()
     {
     return false;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public int[] buildSolvedQuats(Static3D faceAx, Static4D[] quats)
+  protected int[] buildSolvedQuats(Static3D faceAx, Static4D[] quats)
     {
     final float MAXD = 0.0001f;
     float x = faceAx.get0();
@@ -437,39 +457,7 @@ public abstract class TwistyObject extends DistortedNode
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  private int getMultQuat(int index1, int index2)
-    {
-    if( mQuatMult==null )
-      {
-      mQuatMult = new int[NUM_QUATS][NUM_QUATS];
-
-      for(int i=0; i<NUM_QUATS; i++)
-        for(int j=0; j<NUM_QUATS; j++) mQuatMult[i][j] = -1;
-      }
-
-    if( mQuatMult[index1][index2]==-1 )
-      {
-      mQuatMult[index1][index2] = mulQuat(index1,index2);
-      }
-
-    return mQuatMult[index1][index2];
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public boolean isSolved()
-    {
-    if( mSolvedFunctionIndex==0 ) return isSolved0();
-    if( mSolvedFunctionIndex==1 ) return isSolved1();
-    if( mSolvedFunctionIndex==2 ) return isSolved2();
-    if( mSolvedFunctionIndex==3 ) return isSolved3();
-
-    return false;
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public boolean isSolved0()
+  private boolean isSolved0()
     {
     int len, q1,q = CUBITS[0].mQuatIndex;
     int[] solved;
@@ -536,7 +524,7 @@ public abstract class TwistyObject extends DistortedNode
 // (0,1,4), (2,3,6), (5,9,10), (7,8,11)
 // are all the same color.
 
-  public boolean isSolved1()
+  private boolean isSolved1()
     {
     if( mScramble==null )
       {
@@ -587,7 +575,7 @@ public abstract class TwistyObject extends DistortedNode
 // Y cubits: 1, 3, 9, 11
 // Z cubits: 4, 5, 6, 7
 
-  public boolean isSolved2()
+  private boolean isSolved2()
     {
     int qX = CUBITS[0].mQuatIndex;
     int qY = CUBITS[1].mQuatIndex;
@@ -611,7 +599,7 @@ public abstract class TwistyObject extends DistortedNode
 // and all the 12 left and right edges and corners also with the same quat multiplied by
 // QUATS[12] - i.e. also upside down.
 
-  public boolean isSolved3()
+  private boolean isSolved3()
     {
     int index = CUBITS[0].mQuatIndex;
 
@@ -641,26 +629,6 @@ public abstract class TwistyObject extends DistortedNode
     return true;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public void setObjectRatio(float sizeChange)
-    {
-    mObjectScreenRatio *= (1.0f+sizeChange)/2;
-
-    if( mObjectScreenRatio>MAX_SIZE_CHANGE) mObjectScreenRatio = MAX_SIZE_CHANGE;
-    if( mObjectScreenRatio<MIN_SIZE_CHANGE) mObjectScreenRatio = MIN_SIZE_CHANGE;
-
-    float scale = mObjectScreenRatio*mInitScreenRatio*mNodeSize/mRealSize;
-    mObjectScale.set(scale,scale,scale);
-    }
-
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public float getObjectRatio()
-    {
-    return mObjectScreenRatio*mInitScreenRatio;
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   int computeRow(float[] pos, int axisIndex)
@@ -870,18 +838,6 @@ public abstract class TwistyObject extends DistortedNode
     return -1;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public int getCubitFaceColorIndex(int cubit, int face)
-    {
-    Static4D texMap = mMesh.getTextureMap(NUM_FACE_COLORS*cubit + face);
-
-    int x = (int)(texMap.get0()/texMap.get2());
-    int y = (int)(texMap.get1()/texMap.get3());
-
-    return (mNumTexRows-1-y)*NUM_STICKERS_IN_ROW + x;
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // the getFaceColors + final black in a grid (so that we do not exceed the maximum texture size)
 
@@ -920,6 +876,99 @@ public abstract class TwistyObject extends DistortedNode
       }
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private float getAngle()
+    {
+    int pointNum = mRotationAngle.getNumPoints();
+
+    if( pointNum>=1 )
+      {
+      return mRotationAngle.getPoint(pointNum-1).get0();
+      }
+    else
+      {
+      FirebaseCrashlytics crashlytics = FirebaseCrashlytics.getInstance();
+      crashlytics.log("points in RotationAngle: "+pointNum);
+      return 0;
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  private void recordQuatsState(String message)
+    {
+    StringBuilder quats = new StringBuilder();
+
+    for(int j=0; j<NUM_CUBITS; j++)
+      {
+      quats.append(mQuatDebug[j]);
+      quats.append(" ");
+      }
+
+    String name = intGetObjectType(mNumLayers).name();
+
+    if( BuildConfig.DEBUG )
+      {
+      android.util.Log.e("quats" , quats.toString());
+      android.util.Log.e("object", name);
+      }
+    else
+      {
+      Exception ex = new Exception(message);
+      FirebaseCrashlytics crashlytics = FirebaseCrashlytics.getInstance();
+      crashlytics.setCustomKey("quats" , quats.toString());
+      crashlytics.setCustomKey("object", name);
+      crashlytics.recordException(ex);
+      }
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// PUBLIC API
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public boolean isSolved()
+    {
+    if( mSolvedFunctionIndex==0 ) return isSolved0();
+    if( mSolvedFunctionIndex==1 ) return isSolved1();
+    if( mSolvedFunctionIndex==2 ) return isSolved2();
+    if( mSolvedFunctionIndex==3 ) return isSolved3();
+
+    return false;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public void setObjectRatio(float sizeChange)
+    {
+    mObjectScreenRatio *= (1.0f+sizeChange)/2;
+
+    if( mObjectScreenRatio>MAX_SIZE_CHANGE) mObjectScreenRatio = MAX_SIZE_CHANGE;
+    if( mObjectScreenRatio<MIN_SIZE_CHANGE) mObjectScreenRatio = MIN_SIZE_CHANGE;
+
+    float scale = mObjectScreenRatio*mInitScreenRatio*mNodeSize/mRealSize;
+    mObjectScale.set(scale,scale,scale);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public float getObjectRatio()
+    {
+    return mObjectScreenRatio*mInitScreenRatio;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getCubitFaceColorIndex(int cubit, int face)
+    {
+    Static4D texMap = mMesh.getTextureMap(NUM_FACE_COLORS*cubit + face);
+
+    int x = (int)(texMap.get0()/texMap.get2());
+    int y = (int)(texMap.get1()/texMap.get3());
+
+    return (mNumTexRows-1-y)*NUM_STICKERS_IN_ROW + x;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getNumLayers()
@@ -987,35 +1036,6 @@ public abstract class TwistyObject extends DistortedNode
       }
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  public void recordQuatsState(String message)
-    {
-    StringBuilder quats = new StringBuilder();
-
-    for(int j=0; j<NUM_CUBITS; j++)
-      {
-      quats.append(mQuatDebug[j]);
-      quats.append(" ");
-      }
-
-    String name = intGetObjectList(mNumLayers).name();
-
-    if( BuildConfig.DEBUG )
-      {
-      android.util.Log.e("quats" , quats.toString());
-      android.util.Log.e("object", name);
-      }
-    else
-      {
-      Exception ex = new Exception(message);
-      FirebaseCrashlytics crashlytics = FirebaseCrashlytics.getInstance();
-      crashlytics.setCustomKey("quats" , quats.toString());
-      crashlytics.setCustomKey("object", name);
-      crashlytics.recordException(ex);
-      }
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public void releaseResources()
@@ -1165,24 +1185,6 @@ public abstract class TwistyObject extends DistortedNode
     return 0;
     }
 
-///////////////////////////////////////////////////////////////////////////////////////////////////
-
-  private float getAngle()
-    {
-    int pointNum = mRotationAngle.getNumPoints();
-
-    if( pointNum>=1 )
-      {
-      return mRotationAngle.getPoint(pointNum-1).get0();
-      }
-    else
-      {
-      FirebaseCrashlytics crashlytics = FirebaseCrashlytics.getInstance();
-      crashlytics.log("points in RotationAngle: "+pointNum);
-      return 0;
-      }
-    }
-
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public synchronized void removeRotationNow()
@@ -1272,9 +1274,9 @@ public abstract class TwistyObject extends DistortedNode
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType getObjectList()
+  public ObjectType getObjectType()
     {
-    return intGetObjectList(mNumLayers);
+    return intGetObjectType(mNumLayers);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -1306,7 +1308,7 @@ public abstract class TwistyObject extends DistortedNode
   protected abstract ObjectSticker retSticker(int face);
   protected abstract int getFaceColor(int cubit, int cubitface, int numLayers);
   protected abstract int getResource(int mNumLayers);
-  protected abstract ObjectType intGetObjectList(int numLayers);
+  protected abstract ObjectType intGetObjectType(int numLayers);
 
   public abstract Movement getMovement();
   public abstract Static3D[] getRotationAxis();
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
index 8d7608f0..003e41b4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
@@ -115,7 +115,7 @@ public class TwistyBandaged2Bar extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.BAN2_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
index e9ec41ac..5ea51d7f 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
@@ -122,7 +122,7 @@ public class TwistyBandaged3Plate extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.BAN3_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
index 036c922f..2368690e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
@@ -246,7 +246,7 @@ public class TwistyBandagedEvil extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.BAN4_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
index 1591f28c..6e5cbf1a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
@@ -115,7 +115,7 @@ public class TwistyBandagedFused extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC APi
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.BAN1_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCube.java b/src/main/java/org/distorted/objectlib/objects/TwistyCube.java
index 62b214b3..97808d60 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCube.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCube.java
@@ -396,7 +396,7 @@ public class TwistyCube extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
index 3ca6c48f..0d564c23 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
@@ -538,7 +538,7 @@ public class TwistyDiamond extends Twisty8
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
index bd278ef3..35997905 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
@@ -91,14 +91,14 @@ public class TwistyDino4 extends TwistyDino
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public boolean shouldResetTextureMaps()
+  protected boolean shouldResetTextureMaps()
     {
     return true;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.DIN4_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
index 766a995a..588acd41 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
@@ -100,7 +100,7 @@ public class TwistyDino6 extends TwistyDino
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.DINO_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
index d7d87050..4c57b33c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
@@ -458,7 +458,7 @@ public class TwistyHelicopter extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.HELI_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index 2ffd3aa8..f43a1ca6 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -485,7 +485,7 @@ public class TwistyIvy extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.IVY_2;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
index 4d1a5c77..5397dae9 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
@@ -444,7 +444,7 @@ public class TwistyJing extends Twisty4
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.JING_2;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
index ac065d08..8a78fb3c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
@@ -696,7 +696,7 @@ public class TwistyKilominx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
index f5368dc3..cc7833dc 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
@@ -603,7 +603,7 @@ public class TwistyMegaminx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index 6825a198..900b02f1 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -631,7 +631,7 @@ public class TwistyMirror extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index 2828dcd4..fae4965b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -422,7 +422,7 @@ public class TwistyPyraminx extends Twisty4
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
index 617f9891..83e556be 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
@@ -455,7 +455,7 @@ public class TwistyRedi extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.REDI_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
index d2f94706..1235a754 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
@@ -488,7 +488,7 @@ public class TwistyRex extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.REX_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
index 2bad9b61..f0400c6d 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
@@ -597,7 +597,7 @@ public class TwistySkewb extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     switch(numLayers)
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
index bcea5f4b..bd20c7d6 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
@@ -350,7 +350,7 @@ public class TwistySquare1 extends TwistySquare
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.SQU1_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
index e32044a7..fbe4f7b8 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
@@ -383,7 +383,7 @@ public class TwistySquare2 extends TwistySquare
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.SQU2_3;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
index 8c7457d2..2f0a9d21 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
@@ -443,7 +443,7 @@ public class TwistyUltimate extends Twisty12
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public ObjectType intGetObjectList(int numLayers)
+  public ObjectType intGetObjectType(int numLayers)
     {
     return ObjectType.ULTI_2;
     }